/* List examples */
/* ToDo:
  -sorting of the list, lsort function, compare function
  -erasing while list
  -loading/saving list
    a) to/from default file
    b) to/from user defined file

*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// \x1b[2J
#define MAINMENU \
" == Main menu == \
\n \x1b[31;1mA\x1b[0mdd Person \
\n \x1b[31;1mR\x1b[0memove Person \
\n \x1b[31;1mS\x1b[0mort list\n"

typedef struct item {
  struct item *next;
  void *value;
} Item;

void clearline() {
  char c = getchar();
  while (c != '\n') {c=getchar();}
}

/*
add: adds an item behind the element ptr point at */
Item * ladd(Item * ptr,void * value) {
//printf("value: %s",value);
  if (ptr==NULL) { /* list is empty, we create the first entry and return a
                      pointer to it */
    ptr = (Item*)malloc(sizeof(Item));
//printf("new first element %p\n",ptr);
    (*ptr).value = value;
    (*ptr).next = NULL;
    return(ptr);
  } else {
    /* list is not empty, get the next element, and insert the new one before
       it. */
    Item *temp;
    temp = ptr->next;
    ptr->next = (Item*)malloc(sizeof(Item));
    ptr->next->value = value;
    ptr->next->next  = temp;
    return(ptr->next);
  }
};
/* lremove: deletes the item the pointer points add*/
Item * lremove(Item *ptr) {
  if (ptr==NULL) {
    return(ptr);
  } else {
    Item *temp;
    temp=ptr->next;
    free(ptr);
    return(temp);
  }
}
/* lswap: swaps the current element with the following one */
Item * lswap(Item * ptr) {
  if (ptr==NULL|ptr->next==NULL) {
    printf("Tried to spaw but it wouldn't work due to the list's end being so close!\n");
    return(ptr);
  } else {
    Item *temp=ptr;
    ptr=temp->next;
    temp->next=ptr->next;
    ptr->next=temp;
    return(ptr);
  }
}
Item * lget(Item *ptr,unsigned int i) {
  printf(" --- Getting element %i ---\n",i);
  while(ptr&&i>1&&ptr->next!=NULL) {
    printf("%i) %s\n",--i,ptr->value);
    ptr=ptr->next;
  }
  return(ptr);
}

Item * lsort(Item *ptr,int (*fnptr)()) {
  Item *workingptr=ptr;
  Item *subptr,*end;
  void *temp;
  while (workingptr&&workingptr->next) { // run though the whole list
    subptr=ptr;
//    printf(":");
    while (subptr&&subptr!=end&&subptr->next) { // bubblesort: run though the remaining list, sorted element is first, second third etc.
//      printf(".%i",(*fnptr)(subptr->value,subptr->next->value));
      if (0<(*fnptr)(subptr->value,subptr->next->value)) {
        temp=subptr->value;
        subptr->value=subptr->next->value;
        subptr->next->value=temp;
//        printf("#");
      }
      // compare the 2 elements, swap them if necessary,
      end=subptr;
      subptr=subptr->next;
    }

    workingptr=workingptr->next;
  }
  return(ptr);
}

Item *linsert(Item *start,Item *insert) {
  Item *next;
  if (insert) {
    if (start!=NULL) {
      next=start->next;
      start->next=insert;
      while (insert&&insert->next) {
        insert=insert->next;
        printf("!\n");
      }
      insert->next=next;
    } else {
      start = insert;
    }
  }
  return(start);
}

int compare(char *a,char *b) {
  return(strcmp(a,b));
}

int showlist(Item *ptr) {
  int i;
  printf(" --- Content of list ---\n");
  i=0;
  while(ptr) {
    printf("%i) '%s'\n",++i,ptr->value);
    ptr=ptr->next;
  }
  printf(" --- End ---\n");
  return(0);
}
char *removeCRLF(char *str) {
  int i;
  for (i=strlen(str);0<i;i--) { // remove linebreaks
//    printf("-%i:%h",i,buffer[i]);
    if (str[i]==0x0d||str[i]==0x0a) { str[i]='\0';
    }
  }
  return(str);
}

Item *loadfile(FILE *fp) {
  // loadfile builds a completly new list from file fp
  // the list can be later merged with the program's main list.
  Item *start=NULL,*item,*current;
  char *buffer;
  if (fp) {
    buffer=(char*)malloc(32);
    if (fgets(buffer,32,fp)) {
      removeCRLF(buffer);
      start=current=ladd(start,buffer); // insert first element
      buffer=(char*)malloc(32);

      while (fgets(buffer,32,fp)) {      // add other items
        removeCRLF(buffer);
        item=ladd(current,buffer);
        buffer=(char*)malloc(32);
        current->next=item;
        current=current->next;
      }
    }
  }
  return(start);
}

Item *savefile(Item *start,FILE *fp) {
  if (fp&&start) {
    while (start) {
      fputs(start->value,fp);fputc(0x0a,fp);
      start=start->next;
    }
  }
  return(start);
}


int main () {
  Item *start=NULL,*current=NULL;
  Item *temp;
  FILE *fp;
  int running=1;
  int pos;
  char c;
  char *str;
  start=linsert(start,loadfile(fp=fopen("storage.dat","r")));
  fclose(fp);
  do {
    printf(MAINMENU);
    showlist(start);
    printf("Your choice ");
    scanf("%c",&c);
    clearline();
    if (c>90) {c=c-32;} /* upp case*/
    switch (c) {
      case 'A': { /* ADD */
        printf("Please enter name: ");
        str = (char*)malloc(32);
        scanf("%s",str);
        clearline();
        if (start==NULL) { /* List is still -or again-  empty */
          start = ladd(NULL,str);
          printf("Added %s to list",str);
        } else {
          printf("Please enter the position where you want to add the name: ");
          scanf("%i",&pos);
          clearline();
          if (pos <= 1) { /* the first element needs to be modified */
            current =ladd(NULL,str);
            current->next=start;
            start=current;
          } else {
            ladd(lget(start,--pos),str);
          }
        } break;
      }
      case 'R': { // REMOVE
        if (start==NULL) { // List is still -or again-  empty
          break;
        } else {
          printf("Please enter the position of the element you want to remove: ");
          scanf("%i",&pos);
          clearline();
          if (pos <= 1) {  // the first element needs to be modified
            printf("Removing element %i (start)",pos);
            free(start->value);
            start =lremove(start);
          } else {
            current = lget(start,--pos);
            temp=current->next;
            if (temp==NULL) {
              current->next=NULL;
            } else {
              free(temp->value);
              current->next=lremove(temp);
            }
          };
        };
      } break;

      case 'S': {/* sorting */
//        printf("Sorting...\n");
        lsort(start,&compare);
      } break;
//      case 'I': { // inserts a file into the list
//        start=linsert(start,loadfile(fp=fopen("storage.dat","r")));
//        fclose(fp);
//      } break;
/*      case 'W': { // saves the whole list to the file storage.dat
        savefile(start,fopen("storage.dat","a+"));
        fclose(fp);
      } break; */
      case 'X': {
        running=!running;
      } break;
    }
  } while (running);
  savefile(start,fopen("storage.dat","w"));
  fclose(fp);
//  _nheapgrow();
//  printf("Meomory available: %i Max Memory allocatable: %i\n",_memavl(),_memmax());
  return(0);
}


